Release Notes -- Apache Geronimo -- Version 2.1.5


Geronimo URLs
-------------
Home Page:     http://geronimo.apache.org/
Downloads:     http://geronimo.apache.org/downloads.html
Documentation: http://geronimo.apache.org/documentation.html
Mailing Lists: http://geronimo.apache.org/mailing-lists.html
Source Code:   http://geronimo.apache.org/source-code.html
Bug Tracking:  http://issues.apache.org/jira/browse/GERONIMO
Wiki:          http://cwiki.apache.org/geronimo


Documentation
-------------
Please see http://cwiki.apache.org/GMOxDOC21/documentation.html for the
latest documentation on this release.


System Requirements
-------------------
You need a platform that supports the Sun JDK 5.0+ (J2SE 1.5.0+) or greater.

Most testing has been done on Linux, Mac OS X, and Windows.


Geronimo 2.1 Enhancements
-------------------------

Custom server assemblies
- Lightweight server assemblies may be created that contain only the functional 
  components required by your application(s).

Flexible admin console
- The admin console is now component-based to mirror the server capabilities. 
  This allows the admin console to provide flexible administrative capabilities 
  that will mirrors the capabilities of a custom server assembly.

GShell
- GShell is a command-line processing environment that can be used for the execution
  of Geronimo commands. GShell is an extensible environment and includes support
  for editing, command history, and tab completion. 

Clustering Support
- WADI can now be used to support clustering of web applications for Geronimo configurations 
  which use the Tomcat Web Container (WADI support for Jetty was in previous releases). 
- Applications can be deployed to administratively-defined groups of Geronimo servers

Monitoring Console Plugin
- The monitoring console plugin provides monitoring support in the Geronimo admin console. 
  The monitoring console can gather statistics and performance data from multiple Geronimo 
  servers and graphically display this data to users.

Plan Creator (added in Geronimo 2.1.2)
- Plan Creator is a new portlet added to administration console to simplify the creation of 
  Geronimo specific deployment plans. Given a web application archive (war), Plan Creator walks 
  the user through a sequence of steps and generates geronimo-web.xml automatically.


Geronimo 2.1.5 Issues Resolved
------------------------------
** Bug
GERONIMO-5215 Cannot generate eclipse project config files for several modules 
GERONIMO-5204 var/security/keystores seems to be a required directory, but is not being created for custom assemblies 
GERONIMO-5200 high cpu load, probably result of concurrent access of resourcesNotFound in MultiParentClassLoader 
GERONIMO-5191 G 2.1.5 startup console log messages are being generated 
GERONIMO-5180 Deployer unlockKeystore command cannot be utilized if keystore is created through Java provided KeyTool 
GERONIMO-5179 Create a new customized ActiveMQ 4.1.2 build for Geronimo 2.1.5 
GERONIMO-5162 CXF adds a key mapping for WebServiceContext 
GERONIMO-5155 Locking a keystore under "Available" results in exception 
GERONIMO-5150 Connection pool idleReleaser should not expand the number of permits 
GERONIMO-5147 deploy.sh exits with non-zero status because of stty echo 
GERONIMO-5146 Geronimo should provide a default encrypted password for trustStore and keyStore 
GERONIMO-5145 Address getGbean method in KernelDelegate as pointed out by GERONIMO-4844 
GERONIMO-5138 G 2.1 branch activemq build error saying that 'org.codehaus.mojo.jspc:jspc-maven-plugin' has invalid descriptor 
GERONIMO-5134 G 2.1 branch use wrong geronimo-jpa spec version 
GERONIMO-5055 Informix tranql XA 1.2 snapshot leads to weird admin console 
GERONIMO-5043 Informix IFX_XASPEC property to be made available to set through Administrative Console 
GERONIMO-5039 Informix Lock Mode Wait property 
GERONIMO-5036 [OpenEJB] Unable to clear Sun JarFileFactory cache: warning after upgrading to Sun JDK 1.6.0 u18 
GERONIMO-5032 Procrun issue: windows service is stoped when user log off console session 
GERONIMO-5013 ConcurrentModificationException in MultiParentClassLoader.getResource() 
GERONIMO-4997 Can not connect to a ldap server in an anonymous way 
GERONIMO-4993 Requests for db pool resources will exceed Max Pool Size when EJBNetworkService beans are all busy 
GERONIMO-4968 Problemastic OS check in Windows startup command 
GERONIMO-4957 javax.el.CompositeELResolver is not thread-safe 
GERONIMO-4955 Tomcat Clustering via Uni Cast doesn't work 
GERONIMO-4927 keystorePass attribute on TomcatWebSSLConnector GBean should be encrypted/obscured 
GERONIMO-4900 MissingDependencyException while deploying EAR in Clustering Environment 
GERONIMO-4896 Commands to a Secure JMX Connector require the SSL keyStorePassword to be specified on command line 
GERONIMO-4886 Request Time Count attribute does not exist in connector mbean. 
GERONIMO-4869 InheritableThreadLocal causing ClassLoader memory leak in TransactionTimer thread 
GERONIMO-4868 cglib ThreadLocal causing ClassLoader memory leak 
GERONIMO-4859 Default JMX monitoring MBeans list should include JVM MBean. 
GERONIMO-4854 The protocol option will be reset after testing connection when addint server 
GERONIMO-4844 There is an error after undeploy the application and deploy the application again when configure WADI clustering, 
GERONIMO-4825 can not config geronimo as a service in ubuntu 
GERONIMO-4809 Use platform MBean server rather than creating our own 
GERONIMO-4785 "useCaches" property of JarFileUrlConnection doesn't work 
GERONIMO-4782 TemporaryClassLoader loads annotation classes from wrong classloader 
GERONIMO-4771 Defining secondary HostGBean leads to ERROR [JAASRealm] 
GERONIMO-4769 Add English resource bundle for Admin console 
GERONIMO-4764 Missing of JDT compiler in 2.1 branch 
GERONIMO-4758 The Server Console page displays messy codes when set zh as the prefered language in browser 
GERONIMO-4754 Unnecessary attributes retrieval causes slow login in LDAPLoginModule 
GERONIMO-4751 Upgrade 2.1.x to Tomcat 6.0.20 
GERONIMO-4748 Security context is not cleared before the thread is returned to the pool for Tomcat 
GERONIMO-4747 a {0} did not get replaced in the last portlet of console ---> Apache HTTP 
GERONIMO-4733 Unable to starting to configure Apache mod_jk 
GERONIMO-4726 Explicitly shutdown logging during shutdown 
GERONIMO-4722 XSS/XSRF filters are triggering Session object creation for unknown URLs 
GERONIMO-4687 System Modules Portlet doesn't list the stopped application names when you stop an application. 
GERONIMO-4664 OpenSSO Deployment fails with "WSDL generation failed" 
GERONIMO-4662 Console title is not displayed with the correct locale setting 
GERONIMO-4661 Meaningless message displays while Geronimo ear plan contains modules that aren't in the ear 
GERONIMO-4643 Geronimo LDAP realm follow referrals 
GERONIMO-4641 XSSXSRFFilter cause some link failure 
GERONIMO-4640 import link from the Jboss and Weblogic server in Database Pools portlet does not work. 
GERONIMO-4638 ForwardData held by GenericForwardServlet will be invalid after the target application is restarted 
GERONIMO-4635 Security realm changes are lost after restart server 
GERONIMO-4623 Webservice request handling consuming considerable CPU 
GERONIMO-4621 Exception occurs when export debugviews-console-tomcat plugin 
GERONIMO-4620 Database Security Realm is removed from admin consonle after delete datasource it's based 
GERONIMO-4614 Overloaded WSDL operations are not supported 
GERONIMO-4609 Console could not display correctly on Chinese platfrom 
GERONIMO-4608 java.io.EOFException when reading ejb response 
GERONIMO-4607 Useless META-INF dir in the JEE server assembly 
GERONIMO-4605 Text based apache license at the bottom of every console pages 
GERONIMO-4598 Versions missing in plugins: as a result many plugins cannot be added to framework server 
GERONIMO-4597 Validate Web Admin Console input - address admin console security vulnerabilities 
GERONIMO-4595 script error when clicking the update button in portlet console ---server---Server Logs -- Log Manager 
GERONIMO-4589 Does not echo the command after expection occur in command line deploy.sh 
GERONIMO-4588 Adding multiple server with the same host in monitoring portlet results in a sql error 
GERONIMO-4549 JMS resource jndi entries are not removed after uninstalling the JMS connect adapter 
GERONIMO-4545 TomcatJAASRealm keeps reference to undeployed EAR/WAR's classloader 
GERONIMO-4539 Deployment failed if JPA PU jar in web module 
GERONIMO-4533 Fix "This is ridiculous" error messages on command execution 
GERONIMO-4530 unnecessary dependencies in custom server 
GERONIMO-4305 PortletException with Redeploy application checked for non existent application 
GERONIMO-4217 Check for all data primitive types when shortcutting to the primordial classloader 
GERONIMO-4070 Plugin installer fails to install after previous attempt of a plugin has failed. 
GERONIMO-3883 Database wizard looses track of which connector to use if you download a driver jar 
GERONIMO-3599 Unable to create new JMS Resource group through console in IE7 

** Improvement
GERONIMO-5159 Add pause when startup.bat fails on Windows 
GERONIMO-5148 Remove the dependency of clustering over JMXConnector 
GERONIMO-5122 Upgrade Tomcat to 6.0.26 
GERONIMO-4940 CLONE -Tomcat Clustering with WADI - JSESSIONID with jvmRoute to support mod_jk routing (G. 2.1.5) 
GERONIMO-4929 Upgrade to latest tranql wrappers 
GERONIMO-4883 ship agent-car-jmx and make it default agent, mark ejb agent as "load=false". 
GERONIMO-4874 Improve the console filter performance 
GERONIMO-4749 The resource adapter created via console should be deployed as car 
GERONIMO-4729 Duplicate clusterName value sets in config-subsitious.properties 
GERONIMO-4717 There are some texts that aren't pulled out in the activemq portlet. 
GERONIMO-4716 Upgrade HTTPComponent HTTPCore to released version 4.0.1 
GERONIMO-4712 Some INFO log is not very good/useful. 
GERONIMO-4694 Upgrade to Derby 10.5.3.0 
GERONIMO-4686 No clear hints in startup error when 1050 port is already in use. 
GERONIMO-4679 many [ERROR] "The protocol for the JAR file's URL is not supported" in the build log when building geronimo on windows 
GERONIMO-4628 Console plan wizards need to save plans 
GERONIMO-4624 Improve deployment plan documentation 
GERONIMO-4622 Contribution: Linux service script for Geronimo/WAS CE 
GERONIMO-4616 Update xmlbeans plugin 
GERONIMO-4615 Make the client application could use their own Log4j configuration with ApplicationLog4jConfigurationGBean 
GERONIMO-4593 Upgrade to OpenJPA 1.2.2 
GERONIMO-4592 Upgrade to OpenEJB 3.0.2 
GERONIMO-4532 Port the GERONIMO-4484 patch for V2.1 
GERONIMO-4507 Admin console should honor the priority of user agent's language setting 
GERONIMO-3389 console: java.lang.UnsatisfiedLinkError is thrown when create a Tomcat APR HTTP Connector 
GERONIMO-3003 Encrypt password strings in deployment plans 

** New Feature
GERONIMO-5156 Command line utility to unlock a keystore and private key 
GERONIMO-5126 Spnego Support in Apache geronimo 
GERONIMO-5044 Prepared Statement Cache to be made available in Informix XA tranql RA 
GERONIMO-5027 Redeploy option for farming 
GERONIMO-4865 Login module to enable Kerberos authentication 
GERONIMO-4823 role-based administration capabilities
GERONIMO-4810 Predefine a "localhost" server with some predefined graphs and views 


Certification Status
--------------------
Apache Geronimo v2.1.5 has passed 100% of SUN's Java Enterprise Edition 5.0 
Certification Test Suite. See "Distributions" for further details.


Distributions
-------------
Apache Geronimo v2.1.5 is available in five distributions so you can pick the 
one that best fits your environment.

The available distributions are as follows:

Certified distributions:
- Apache Geronimo with Tomcat web container, AXIS2 for Web Services and OpenJPA
  for persistence.
- Apache Geronimo with Jetty web container, CXF for Web Services and OpenJPA 
  for persistence.

Non-Certified distributions:
- Little-G with Tomcat web container, minimal configuration.
- Little-G with Jetty web container, minimal configuration.
- Geronimo framework, stripped down Geronimo pluggable framework.

Note: Non-Certified distributions do not contain a complete JavaEE5 stack and so 
cannot be certified.  Certified distributions can be reconfigured by the user 
(such as Tomcat web container with CXF for Web Services). 


Supported features
------------------
All programming elements of the Java EE 5.0 Specification are available.  


Known Issues and Limitations
----------------------------
** Bug
GERONIMO-5181 Modification to Database connection pool parameters are not saved when restart Geronimo. 
GERONIMO-5160 Fail to create Database Pool for DB2(DataDirect) and Informix(DataDirect) 
GERONIMO-5137 EJB security config in ejb-jar.xml does not override the ones defined via security annotations 
GERONIMO-4901 Shutting down Geronimo destroys pending Timers 
GERONIMO-4887 java.lang.SecurityException: Invalid login when edit a running jmx server 
GERONIMO-4845 the view is also existed after I delete the server in monitoting portlet 
GERONIMO-4775 Need to convert static English images into translatable text in Admin console 
GERONIMO-4757 "java.lang.IllegalStateException" error when use install-plugin goal 
GERONIMO-4731 Jetty build does not support IPV6 address in browser. 
GERONIMO-4688 hardcode port in plan.xml of plugin farming. 
GERONIMO-4634 PlanCreator does not work for some applications

